%% Large scale spectral clustering via landmark-based representation
% INPUT:
%   X     - Data matrix, columns are samples.
%
%   K  -    number of clusters
%
%   Gt  -   correct clusters (ground truth)
%
%OUTPUT:
% 
% idx   -  vector containing cluster indexes for each sample
%
function [ idx ] = landmark_based_SC( X, K, Gt )
 % NOTE - this method requires EKM
    
    for i=1:size(X,1)
        d(i)=1/sqrt(sum(X(i,:)));
    end
    Dhs=diag(d);
    Xh = Dhs*X;
    [A,S,V] = svdsecon(Xh*Xh',K);
    Si=diag(1./diag(S));
    V=transpose(Si*A'*Xh);
    clear Xh Dhs
    V = normr(V);
    n = size(V,1);
    M = zeros(K,K,20);
    rand('state',123456789);
    for i=1:size(M,3)
        inds = false(n,1);
        while sum(inds)<K
            j = ceil(rand()*n);
            inds(j) = true;
        end
        M(:,:,i) = V(inds,:);
    end
    
    idx = kmeans(V,K,'emptyaction','singleton','Replicates',size(M,3),'start',M,'display','off');

end

